<template>
  <li>
    <form v-if="isEditEnabled" @submit.prevent="saveChanges">
      <label>
        <span>Vorname</span>
        <input type="text" name="firstName" placeholder="Max" v-model.trim="firstName" required>
      </label>
      <label>
        <span>Nachname</span>
        <input type="text" name="lastName" placeholder="Muster" v-model.trim="lastName" required>
      </label>
      <button type="submit" class="btn btn-sm btn-primary">Speichern</button>
      <button type="button" class="btn btn-sm btn-secondary" @click="abortEdit">Abbrechen</button>
    </form>
    <div v-else>
      {{props.person?.firstName}} {{props.person?.lastName}}
      <button @click="isEditEnabled = true">edit</button>
      <router-link :to="'/persons/' + index" class="btn btn-sm btn-success">Details</router-link>
    </div>
  </li>
</template>

<script setup>
//defineProps(['person'])

import {ref} from "vue";

const props = defineProps({
  person: {
    type: Object,
    default: () => ({ firstName: 'generic', lastName: 'name'})
  },
  index: {
    type: Number,
    required: true
  }
})

const emit = defineEmits(['update'])

const isEditEnabled = ref(false)
const firstName = ref(props.person?.firstName); // 🤡🤡🤡
const lastName = ref(props.person?.lastName)

function abortEdit() {
  isEditEnabled.value = false
  firstName.value = props.person?.firstName
  lastName.value = props.person?.lastName
}

function saveChanges() {
  /*props.person = {
    firstName: firstName.value,
    lastName: lastName.value
  }*/
  emit('update', {
    firstName: firstName.value,
    lastName: lastName.value
  }, props.person)
}
</script>
